# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

rsat_source = "RSAT_1903_x64"  # You can specify a network access
rsat_capability_all = (
    "Rsat.ActiveDirectory.DS-LDS.Tools~~~~0.0.1.0",
    "Rsat.BitLocker.Recovery.Tools~~~~0.0.1.0",
    "Rsat.CertificateServices.Tools~~~~0.0.1.0",
    "Rsat.DHCP.Tools~~~~0.0.1.0",
    "Rsat.Dns.Tools~~~~0.0.1.0",
    "Rsat.FailoverCluster.Management.Tools~~~~0.0.1.0",
    "Rsat.FileServices.Tools~~~~0.0.1.0",
    "Rsat.GroupPolicy.Management.Tools~~~~0.0.1.0",
    "Rsat.IPAM.Client.Tools~~~~0.0.1.0",
    "Rsat.LLDP.Tools~~~~0.0.1.0",
    "Rsat.NetworkController.Tools~~~~0.0.1.0",
    "Rsat.NetworkLoadBalancing.Tools~~~~0.0.1.0",
    "Rsat.RemoteAccess.Management.Tools~~~~0.0.1.0",
    "Rsat.RemoteDesktop.Services.Tools~~~~0.0.1.0",
    "Rsat.ServerManager.Tools~~~~0.0.1.0",
    "Rsat.Shielded.VM.Tools~~~~0.0.1.0",
    "Rsat.StorageMigrationService.Management.Tools~~~~0.0.1.0",
    "Rsat.StorageReplica.Tools~~~~0.0.1.0",
    "Rsat.SystemInsights.Management.Tools~~~~0.0.1.0",
    "Rsat.VolumeActivation.Tools~~~~0.0.1.0",
    "Rsat.WSUS.Tools~~~~0.0.1.0",
)
# rsat_capability_to_install = rsat_capability_all
rsat_capability_to_install = (
    "Rsat.ActiveDirectory.DS-LDS.Tools~~~~0.0.1.0",
    "Rsat.Dns.Tools~~~~0.0.1.0",
    "Rsat.GroupPolicy.Management.Tools~~~~0.0.1.0",
    "Rsat.LLDP.Tools~~~~0.0.1.0",
    "Rsat.RemoteAccess.Management.Tools~~~~0.0.1.0",
)


def install():
    # Getting the used storage on programfiles before installation (place it on the top)
    get_disk_free_space_before = get_disk_free_space(programfiles)

    # Installing the package
    with EnsureWUAUServRunning():
        try:
            if windows_version() >= "10.0.18361":
                for capabilities in rsat_capability_to_install:
                    # state = run_powershell('Get-WindowsCapability -Online | Where Name -like "%s" | Select State' % capabilities)
                    # if state['State'] == 4:
                    #    print('Already installed: %s' % capabilities)
                    # else:
                    print("Installing: %s" % capabilities)
                    try:
                        run_powershell('Add-WindowsCapability -Online -Name "%s" -LimitAccess -Source "%s"' % (capabilities, rsat_source))
                    except:
                        print("Installation failed on: %s" % capabilities)
                        continue
            else:
                print("This Windows 10 version is not compatible with this package")
        except:
            print("A reboot is probably required")

    # Return used storage of the program. (place it on the bottom)
    get_disk_free_space_after = get_disk_free_space(programfiles)
    free_space_after_diff = get_disk_free_space_before - get_disk_free_space_after
    print("Storage used: " + str(free_space_after_diff))


def uninstall():
    print("Uninstalling all installed RSAT features")

    with EnsureWUAUServRunning():
        try:
            for capabilities in rsat_capability_all:
                print("Uninstalling: %s" % capabilities)
                try:
                    run_powershell('Remove-WindowsCapability -Online -Name "%s"' % capabilities)
                except:
                    print("Uninstallation failed on: %s" % capabilities)
                    continue
        except:
            print("A reboot is probably required")


def audit():
    import pprint

    print("Showing installed")
    pprint.pprint(run_powershell("Get-WindowsCapability -Online | Where Name -like Rsat* | Where State -Like Installed | Select Name,RestartNeeded"))
    print("Showing not installed RSAT features")
    pprint.pprint(
        run_powershell("Get-WindowsCapability -Online | Where Name -like Rsat* | Where State -NotLike Installed | Select Name,RestartNeeded")
    )
    return "OK"


def update_package():
    pass


if __name__ == "__main__":
    update_package()
